package com.example.mynotepad;

import androidx.appcompat.app.AppCompatActivity;
import androidx.drawerlayout.widget.DrawerLayout;
import androidx.room.Room;
import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.view.Gravity;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import com.example.mynotepad.MenuFeatures.AllArchivedNotes.ArchivedNotesActivity;
import com.example.mynotepad.MenuFeatures.AllNotes.AllNotesActivity;
import com.example.mynotepad.MenuFeatures.AllNotes.DataBase.NoteDataBase;
import com.example.mynotepad.MenuFeatures.Calender.MyCalenderActivity;
import com.example.mynotepad.MenuFeatures.Pics.PicsActivity;
import com.example.mynotepad.MenuFeatures.Setting.SettingActivity;
import com.example.mynotepad.MenuFeatures.VoiceMassages.VoiceMassagesActivity;
import com.google.android.material.navigation.NavigationView;

public class MainActivity extends AppCompatActivity implements NavigationView.OnNavigationItemSelectedListener {

    public static NoteDataBase noteDataBase;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        init();
    }

    private void init() {
        noteDataBase = Room.databaseBuilder(this, NoteDataBase.class, "RoomDb").fallbackToDestructiveMigration().allowMainThreadQueries().build();

        final DrawerLayout drawerLayout = findViewById(R.id.drawerLayout);
        NavigationView navigationView = findViewById(R.id.main_menu);//menu drawer in ui
        navigationView.setNavigationItemSelectedListener(this);

        ImageView toolbarListImg = findViewById(R.id.toolbarList);
        toolbarListImg.setOnClickListener(new View.OnClickListener() {
            @SuppressLint("WrongConstant")
            @Override
            public void onClick(View v) {
                if(!drawerLayout.isDrawerOpen(Gravity.START))
                    drawerLayout.openDrawer(Gravity.START);
                else drawerLayout.closeDrawer(Gravity.END);
            }
        });
    }

    public void allNoteClicked(View view){
        startActivity(new Intent(getApplicationContext(), AllNotesActivity.class));
    }

    public void onCalendarClicked(View view){
        startActivity(new Intent(getApplicationContext(), MyCalenderActivity.class));
    }

    public void onVoiceMassagesClicked(View view){
        startActivity(new Intent(getApplicationContext(), VoiceMassagesActivity.class));
    }

    public void noNotedPicsClicked(View view){
        startActivity(new Intent(getApplicationContext(), PicsActivity.class));
    }

    public void onProgramsClicked(View view){

    }

    @SuppressLint("NonConstantResourceId")
    @Override
    public boolean onNavigationItemSelected(MenuItem item) {
        // Handle navigation view item clicks here.
        int id = item.getItemId();

        switch (id) {
            case R.id.favorites:{
                startActivity(new Intent(getApplicationContext(), ArchivedNotesActivity.class));
                break;
            }
            case R.id.folders:{
                break;
            }
            case R.id.setting:{
                startActivity(new Intent(getApplicationContext(), SettingActivity.class));
            }
            case R.id.information:{
            }
        }
        return true;
    }
}